#!/usr/bin/python3
# -*- coding: UTF-8 -*-
# Author	  : William
# Date		: 2019/10/12

from socket import *
import time
import tkinter as tk

RPI_IP = '192.168.3.77'
SERVER_PORT = 10223

BUFSIZ = 1024
ADDR = (RPI_IP, SERVER_PORT)
tcpClicSock = socket(AF_INET, SOCK_STREAM)
tcpClicSock.connect(ADDR)

P_move = 0
T_move = 0

color_bg   = '#000000'
color_text = '#E1F5FE'
color_btn  = '#212121'


def PT_buttons(x,y):
	def call_left(event):
		global P_move
		if P_move == 0:
			tcpClicSock.send(('left').encode())
			P_move = 1

	def call_right(event):
		global P_move
		if P_move == 0:
			tcpClicSock.send(('right').encode())
			P_move = 1

	def call_up(event):
		global T_move
		if T_move == 0:
			tcpClicSock.send(('up').encode())
			T_move = 1

	def call_down(event):
		global T_move
		if T_move == 0:
			tcpClicSock.send(('down').encode())
			T_move = 1

	def call_TStop(event):
		global T_move
		tcpClicSock.send(('T_no').encode())
		T_move = 0

	def call_PStop(event):
		global P_move
		tcpClicSock.send(('P_no').encode())
		P_move = 0

	Btn_0 = tk.Button(root, width=8, text='Left',fg=color_text,bg=color_btn,relief='ridge')
	Btn_0.place(x=x,y=y+35)
	Btn_0.bind('<ButtonPress-1>', call_left)
	Btn_0.bind('<ButtonRelease-1>', call_PStop)
	root.bind('<KeyPress-a>', call_left)
	root.bind('<KeyRelease-a>', call_PStop)

	Btn_1 = tk.Button(root, width=8, text='Up',fg=color_text,bg=color_btn,relief='ridge')
	Btn_1.place(x=x+70,y=y)
	Btn_1.bind('<ButtonPress-1>', call_up)
	Btn_1.bind('<ButtonRelease-1>', call_TStop)
	root.bind('<KeyPress-w>', call_up)
	root.bind('<KeyRelease-w>', call_TStop) 

	Btn_1 = tk.Button(root, width=8, text='Down',fg=color_text,bg=color_btn,relief='ridge')
	Btn_1.place(x=x+70,y=y+35)
	Btn_1.bind('<ButtonPress-1>', call_down)
	Btn_1.bind('<ButtonRelease-1>', call_TStop)
	root.bind('<KeyPress-s>', call_down)
	root.bind('<KeyRelease-s>', call_TStop)

	Btn_2 = tk.Button(root, width=8, text='Right',fg=color_text,bg=color_btn,relief='ridge')
	Btn_2.place(x=x+140,y=y+35)
	Btn_2.bind('<ButtonPress-1>', call_right)
	Btn_2.bind('<ButtonRelease-1>', call_PStop)
	root.bind('<KeyPress-d>', call_right) 
	root.bind('<KeyRelease-d>', call_PStop) 


def CB_button(x,y):
	def draw(event):
		tcpClicSock.send(('draw').encode())


	def loose(event):
		tcpClicSock.send(('loose').encode())

	Btn_Switch_1 = tk.Button(root, width=8, text='Draw',fg=color_text,bg=color_btn,relief='ridge')
	Btn_Switch_2 = tk.Button(root, width=8, text='Loose',fg=color_text,bg=color_btn,relief='ridge')

	Btn_Switch_1.place(x=x,y=y)
	Btn_Switch_2.place(x=x+70,y=y)

	Btn_Switch_1.bind('<ButtonPress-1>', draw)
	root.bind('<KeyPress-r>', draw)

	Btn_Switch_2.bind('<ButtonPress-1>', loose)
	root.bind('<KeyPress-f>', loose)


def loop():
	global root
	root = tk.Tk()			
	root.title('GUI')	  
	root.geometry('260x160')  
	root.config(bg=color_bg)  

	try:
		logo =tk.PhotoImage(file = 'logo.png')
		l_logo=tk.Label(root,image = logo,bg=color_bg)
		l_logo.place(x=30,y=13)
	except:
		pass

	PT_buttons(30,30)

	CB_button(65,110)

	root.mainloop()


if __name__ == '__main__':
	loop()